#include <iom16v.h>
#include <macros.h>

#define lcd_data_port PORTD
#define lcd_data_ddr DDRD
#define lcd_busy_pin PIND
#define lcd_busy_ddr DDRD
#define lcd_control_port PORTA
#define lcd_control_ddr DDRA

#define lcd_RS 0x01	//PORT?^0
#define lcd_RW 0x02	//PORT?^1
#define lcd_EN 0x04	//PORT?^2
#define busy 0x80	//LCD_DB7

/*----------------------------------------------------------------------------*/
void lcd_init(void);
void lcd_write_command(unsigned char command,unsigned char wait_en);
void lcd_write_data(unsigned char char_data);
void wait_enable(void);
void display_a_char(unsigned char position,unsigned char char_data);
void display_a_string(unsigned char col,unsigned char *ptr);
void delay_1ms(void);
void delay_nms(unsigned int n);

//ʾַ
unsigned char str1[]="   neutronlmk   ";
unsigned char str2[]=" www.ouravr.com ";

/*-------------------------------------------------------------------------------*/
void main(void)
{
	lcd_data_port=0xff;
	lcd_data_ddr=0xff;
	lcd_control_port=0x07;
	lcd_control_ddr=0x07;
	lcd_init();
	display_a_string(0,str1);
	display_a_string(1,str2);
	while(1);
}
	
/*------------------------------------Һ-------------------------------------*/
//Һʼ
void lcd_init(void)
{
	delay_nms(15);
	lcd_write_command(0x38,0);//ʾģʽ(ʱlcd)
	delay_nms(5);
	lcd_write_command(0x38,0);
	delay_nms(5);
	lcd_write_command(0x38,0);
	delay_nms(5);
	
	lcd_write_command(0x38,1);//ʾģʽ(Ӵ֮lcd)
	lcd_write_command(0x08,1);//ʾر
	lcd_write_command(0x01,1);//ʾ
	lcd_write_command(0x06,1);//ʾƶ
	lcd_write_command(0x0c,1);//ʾ
}

//дָ: E= RS=0 RW=0
void lcd_write_command(unsigned char command,unsigned char wait_en)//commandΪָwait_enָǷҪLCDæź
{
	if(wait_en)wait_enable();//wait_enΪ1ҪLCDæźţȴ
	lcd_control_port&=~lcd_RS;//RS=0
	lcd_control_port&=~lcd_RW;//RW=0
	lcd_control_port&=~lcd_EN;//E=0,LCDһ
	NOP();
	lcd_control_port|=lcd_EN;//E=1
	lcd_data_port=command;
	lcd_control_port&=~lcd_EN;//E=0
}

//дݺ: E = RS=1 RW=0
void lcd_write_data(unsigned char char_data)
{
	wait_enable();//ȴLCD
	lcd_control_port|=lcd_RS;//RS=1
	lcd_control_port&=~lcd_RW;//RW=0
	lcd_control_port&=~lcd_EN;//E=0,LCDһ
	NOP();
	lcd_control_port|=lcd_EN;//E=1
	lcd_data_port=char_data;
	lcd_control_port&=~lcd_EN;//E=0
}

//д֮ǰLCD״̬:E=1 RS=0 RW=1;DB7: 0 LCDУ1 LCDæ
//æź,ȴLCDк
void wait_enable(void)
{
	lcd_busy_ddr&=~busy;//busyΪ
	lcd_control_port&=~lcd_RS;//RS=0
	lcd_control_port|=lcd_RW;//RW=1
	NOP();
	lcd_control_port|=lcd_EN;//E=1
	while(lcd_busy_pin&busy);//ȴLCD_DB7Ϊ0
	lcd_control_port&=~lcd_EN;//E=0
	lcd_busy_ddr|=busy;//busyΪ
}

//ָλʾһַ:һλ0~15,ڶ16~31
//ʾһַ
void display_a_char(unsigned char position,unsigned char char_data)//positionָλ0~31,char_dataΪҪʾַ
{
	unsigned char position_tem;
	if(position>=0x10)
	position_tem=position+0xb0;
	else
	position_tem=position+0x80;
	lcd_write_command(position_tem,1);
	lcd_write_data(char_data);
}

//ָһʾַ:0ʾڵһ,1ʾڵڶ,עַܳ16ַ
//ʾһַ
void display_a_string(unsigned char col,unsigned char *ptr)//colָ,*ptrַָָ
{
	unsigned char col_tem,i;
	col_tem=col<<4;//colΪ1(LCDڶʾַ),Ȱcol4λ,ʹʾַλøĵڶλ,λ16
	for(i=0;i<16;i++)
	display_a_char(col_tem++,*(ptr+i));
}

/*---------------------------------------ʱ-------------------------------------*/
//1msʱ
void delay_1ms(void)
{
	unsigned int i;
	for(i=0;i<600;i++);
}

//n msʱ
void delay_nms(unsigned int n)
{
	unsigned int i;
	for(i=0;i<n;i++)delay_1ms();
}
